#include <stdio.h>
#include <stdlib.h>

typedef struct
{
    int nap;
    char varos[3];
    int darab;
} rendeles;

typedef rendeles rendeles_tomb[1000];

typedef struct
{
    int pl[3];
    int tv[3];
    int nr[3];
} varosok;

void feladat1(rendeles *rendelesek, int *rendelesek_szama, int *nr_varos_napi_rendelesek, int *legnagyobb_darabszam, varosok *rendelesek_varosonkent)
{
    FILE *r = fopen("rendel.txt", "r");
    int i = 0;
    while (fscanf(r, "%d %s %d", &rendelesek[i].nap, rendelesek[i].varos, &rendelesek[i].darab) == 3)
    {
        //printf("%d %s %d\n", rendelesek[i].nap, rendelesek[i].varos, rendelesek[i].darab);
        if (rendelesek[i].darab > *legnagyobb_darabszam)
        {
            *legnagyobb_darabszam = rendelesek[i].darab;
        }
        if (rendelesek[i].varos[0] == 'P')
        {
            //(*rendelesek_varosonkent).pl[(rendelesek[i].nap - 1) / 10]++;
            rendelesek_varosonkent->pl[(rendelesek[i].nap - 1) / 10]++;
        }
        else if (rendelesek[i].varos[0] == 'T')
        {
            rendelesek_varosonkent->tv[(rendelesek[i].nap - 1) / 10]++;
        }
        else
        {
            nr_varos_napi_rendelesek[rendelesek[i].nap - 1]++;
            rendelesek_varosonkent->nr[(rendelesek[i].nap - 1) / 10]++;
        }
        i++;
    }
    *rendelesek_szama = i;
    fclose(r);
}

void feladat2(int rendelesek_szama)
{
    printf("2. feladat:\nA rendelesek szama: %d", rendelesek_szama);
}

void feladat3(rendeles *rendelesek, int rendelesek_szama)
{
    int nap, adott_napi_rendelesek_szama = 0;
    printf("\n3. feladat:\nKerem, adjon meg egy napot: ");
    scanf("%d", &nap);
    for (int i = 0; i < rendelesek_szama && nap >= rendelesek[i].nap; i++)
    {
        if (rendelesek[i].nap == nap)
        {
            adott_napi_rendelesek_szama++;
        }
    }
    printf("A rendelesek szama az adott napon: %d", adott_napi_rendelesek_szama);
}

void feladat4(int *nr_varos_napi_rendelesek)
{
    int rendeles_nelkuli_napok_szama = 0;
    printf("\n4. feladat:\n");
    for (int i = 0; i < 30; i++)
    {
        if (nr_varos_napi_rendelesek[i] == 0)
        {
            rendeles_nelkuli_napok_szama++;
        }
    }
    if (rendeles_nelkuli_napok_szama > 0)
    {
        printf("%d nap nem volt a reklamban nem erintett varosbol rendeles", rendeles_nelkuli_napok_szama);
    }
    else
    {
        printf("Minden nap volt rendeles a reklamban nem erintett varosbol");
    }
}

void feladat5(rendeles *rendelesek, int rendelesek_szama, int legnagyobb_darabszam)
{
    /*for (int i = 0; i < rendelesek_szama; i++)
    {
        if (rendelesek[i].darab == legnagyobb_darabszam)
        {
            printf("\n5. feladat:\nA legnagyobb darabszam: %d, a rendeles napja: %d", legnagyobb_darabszam, rendelesek[i].nap);
            break;
        }
    }*/
    int i;
    for (i = 0; i < rendelesek_szama && rendelesek[i].darab != legnagyobb_darabszam; i++);
    if (i < rendelesek_szama)
    {
        printf("\n5. feladat:\nA legnagyobb darabszam: %d, a rendeles napja: %d", legnagyobb_darabszam, rendelesek[i].nap);
    }
}

int osszes(rendeles *rendelesek, int rendelesek_szama, char *varos, int nap)
{
    int rendelt_termekek_szama = 0;
    for (int i = 0; i < rendelesek_szama; i++)
    {
        if (rendelesek[i].varos[0] == varos[0] && rendelesek[i].nap == nap)
        {
            rendelt_termekek_szama += rendelesek[i].darab;
        }
    }
    return rendelt_termekek_szama;
}

void feladat7(rendeles *rendelesek, int rendelesek_szama)
{
    printf("\n7. feladat:\nA rendelt termekek darabszama a 21. napon PL: %d TV: %d NR: %d", osszes(rendelesek, rendelesek_szama, "PL", 21), osszes(rendelesek, rendelesek_szama, "TV", 21), osszes(rendelesek, rendelesek_szama, "NR", 21));
}

void feladat8(rendeles *rendelesek, int rendelesek_szama, varosok rendelesek_varosonkent)
{
    FILE *k = fopen("kampany.txt", "w");
    printf("\n8. feladat:\nNapok\t1..10\t11..20\t21..30");
    printf("\nPL\t%d\t%d\t%d", rendelesek_varosonkent.pl[0], rendelesek_varosonkent.pl[1], rendelesek_varosonkent.pl[2]);
    printf("\nTV\t%d\t%d\t%d", rendelesek_varosonkent.tv[0], rendelesek_varosonkent.tv[1], rendelesek_varosonkent.tv[2]);
    printf("\nNR\t%d\t%d\t%d", rendelesek_varosonkent.nr[0], rendelesek_varosonkent.nr[1], rendelesek_varosonkent.nr[2]);
    fprintf(k, "Napok\t1..10\t11..20\t21..30");
    fprintf(k, "\nPL\t%d\t%d\t%d", rendelesek_varosonkent.pl[0], rendelesek_varosonkent.pl[1], rendelesek_varosonkent.pl[2]);
    fprintf(k, "\nTV\t%d\t%d\t%d", rendelesek_varosonkent.tv[0], rendelesek_varosonkent.tv[1], rendelesek_varosonkent.tv[2]);
    fprintf(k, "\nNR\t%d\t%d\t%d", rendelesek_varosonkent.nr[0], rendelesek_varosonkent.nr[1], rendelesek_varosonkent.nr[2]);
    fclose(k);
}

int main()
{
    rendeles_tomb rendelesek;
    varosok rendelesek_varosonkent = {0};
    int rendelesek_szama, nr_varos_napi_rendelesek[30] = {0}, legnagyobb_darabszam = 0;
    feladat1(rendelesek, &rendelesek_szama, nr_varos_napi_rendelesek, &legnagyobb_darabszam, &rendelesek_varosonkent);
    feladat2(rendelesek_szama);
    feladat3(rendelesek, rendelesek_szama);
    feladat4(nr_varos_napi_rendelesek);
    feladat5(rendelesek, rendelesek_szama, legnagyobb_darabszam);
    feladat7(rendelesek, rendelesek_szama);
    feladat8(rendelesek, rendelesek_szama, rendelesek_varosonkent);
    return 0;
}
